#!/usr/bin/perl

use strict;
use Gtk2Fu qw(:all);

Gtk2->init;

my $w = create_window();
$w->signal_connect_(destroy => sub { Gtk2->main_quit })
  ->add_(new Gtk2::VBox(0, 0)
         ->gtkpack_(0, new Gtk2::HBox(0, 0)
                    ->gtkpack_(0, powered_by_libconf())
                   )
        )
  ->show_all_();
Gtk2->main;

sub powered_by_libconf {
    my $filename = $_[0];
    if ( !-e $filename) {
        require Libconf;
        $filename = $INC{'Libconf.pm'};
        $filename =~ s|Libconf.pm$|Libconf/libconf_powered.png|;
    }
    -e $filename or die "couldn't find any png image to load : " . $INC{'Libconf'} . "/libconf_powered.png";
    my $darea;
    my $pixbuf = Gtk2::Gdk::Pixbuf->new_from_file($filename);
    my $gc;
    my %c;
    my $draw;
    my $launch_draw_timeout = sub { Glib::Timeout->add(30, $draw); 0 };
    $draw = sub {
        defined $darea->window or return 0;
        my (undef, undef, $width, $height, undef) = $darea->window->get_geometry();
        $gc ||= Gtk2::Gdk::GC->new($darea->window);
        %c or %c = ('x' => int(rand($width)), 'y' => int(rand($height)), max_height => int($height*2/3));
        $darea->window->draw_pixbuf($gc, $pixbuf, 0, 0, 0, 0, $width, $height, 'none', undef, undef);
        $darea->window->draw_arc($gc, 0, @c{qw(x y width height)}, 0, 360*64);
        if ($c{rewind}) { $c{width}-=2; $c{height}-=2; $c{'x'}++; $c{'y'}++ } else { $c{width}+=2; $c{height}+=2; $c{'x'}--; $c{'y'}-- }
        $c{height} > $c{max_height} and $c{rewind} = 1;
        if ($c{height} < 0) {
            undef %c;
            Glib::Timeout->add(rand((int(rand(4))+1)*1000), $launch_draw_timeout);
            $darea->window->draw_pixbuf($gc, $pixbuf, 0, 0, 0, 0, $width, $height, 'none', undef, undef);
            0
        } else { 1 }
    };
    $darea = Gtk2::DrawingArea->new()
      ->signal_connect_(expose_event => $draw)
      ->set_size_request_($pixbuf->get_width(), $pixbuf->get_height());
    $launch_draw_timeout->(); $darea;
}

