#!/usr/bin/perl

use Libconf::Glueconf::Generic::KeyValue;
use Data::Dumper;
use Libconf::Test;
$Libconf::Test::test_module_name = 'keyvalue';

# test 1, minimal requirement : regenerate correctly
Libconf::Test::display(1);
my $autologin = new Libconf::Glueconf::Generic::KeyValue({ filename => 'autologin',
                                                           separator_char => '=',
                                                           allow_space => 0,
                                                           comments_struct => [['#']],
                                                           handle_quote => 1,
                                                           handle_multiples_lines => 0,
                                                         });
$autologin->write_conf('keyvalue_output_1');
Libconf::Test::test(1);

# test 2, modifying some infos
Libconf::Test::display(2);
$autologin->{USER} = 'foo';
$autologin->write_conf('keyvalue_output_2');
Libconf::Test::test(2);

# test 3, virtuals
Libconf::Test::display(3);
my $virtuals = new Libconf::Glueconf::Generic::KeyValue({ filename => 'virtuals',
                                                          separator_char => '\s+',
                                                          output_separator_char => "\t",
                                                          allow_space => 0,
                                                          comments_struct => [['#']],
                                                          handle_quote => 1,
                                                          handle_multiples_lines => 0,
                                                        });
#print Dumper($virtuals) . "\n";
$virtuals->write_conf('keyvalue_output_3');
Libconf::Test::test(3);

# test 4, modifying some infos
Libconf::Test::display(4);
$virtuals->{USER} = 'foo';
$virtuals->write_conf('keyvalue_output_4');
Libconf::Test::test(4);


# test 5, use.desc
Libconf::Test::display(5);
my $use_desc = new Libconf::Glueconf::Generic::KeyValue({ filename => "use.desc",
                                                          separator_char => '-',
                                                          allow_space => 1,
                                                          handle_quote => 0,
                                                          accept_empty_value => 1,
                                                        });
{
    local $|=1;
    my $t = scalar (keys %$use_desc);
    while(my ($key, $value) = each %$use_desc) {
        $i++;
    }
}
#$virtuals->write_conf('keyvalue_output_3');
#Libconf::Test::test(3);


Libconf::Test::display(-1);
