#!/usr/bin/perl

use Libconf::Glueconf::Networking::Resolv;
use Data::Dumper;
use Libconf::Test;
$Libconf::Test::test_module_name = 'resolv';

# test 1, minimal requirement : regenerate correctly
Libconf::Test::display(1);
my $resolv = new Libconf::Glueconf::Networking::Resolv({filename => 'resolv.conf' });
$resolv->write_conf('resolv_output_1');
Libconf::Test::test(1);

# test 2, modifying some infos
Libconf::Test::display(2);
push(@{$resolv->{nameserver}}, '192.168.76.7');
$resolv->write_conf('resolv_output_2');
Libconf::Test::test(2);

# test 3, modifying some more infos
Libconf::Test::display(3);
splice(@{$resolv->{nameserver}}, 1, 2, '192.168.76.222', '192.168.76.223');
$resolv->write_conf('resolv_output_3');
Libconf::Test::test(3);

# test 4, modifying some more infos
Libconf::Test::display(4);
$resolv->{search}->[1] = 'foo';
$resolv->write_conf('resolv_output_4');
Libconf::Test::test(4);

Libconf::Test::display(-1);
