#!/usr/bin/perl

use Libconf::Glueconf::Samba::Smb_conf;
use Data::Dumper;
use Libconf::Test;
$Libconf::Test::test_module_name = 'samba';

# test 1, minimal requirement : regenerate correctly
Libconf::Test::display(1);
my $samba = new Libconf::Glueconf::Samba::Smb_conf({ filename => 'smb.conf' });
$samba->write_conf('samba_output_1');
Libconf::Test::test(1);


# test 2, editing an atom
Libconf::Test::display(2);
$samba = new Libconf::Glueconf::Samba::Smb_conf({ filename => 'smb.conf' });
$samba->{homes}->{writable} = 'TEST';
$samba->write_conf('samba_output_2');
Libconf::Test::test(2);

# test 3, appending an atom
Libconf::Test::display(3);
$samba = new Libconf::Glueconf::Samba::Smb_conf({ filename => 'smb.conf' });
$samba->{partage}->{K1} = 'yo';
$samba->write_conf('samba_output_3');
Libconf::Test::test(3);

# test 4, inserting a atom
Libconf::Test::display(4);
$samba = new Libconf::Glueconf::Samba::Smb_conf({ filename => 'smb.conf' });
$samba->{homes}->{TESTkey} = 'TESTvalue';
$samba->write_conf('samba_output_4');
Libconf::Test::test(4);

# test 5, getting an atom
Libconf::Test::display(5);
$samba = new Libconf::Glueconf::Samba::Smb_conf({ filename => 'smb.conf' });
$samba->{global}->{workgroup} eq 'MDKGROUP' or Libconf::Test::failed(5);

# test 6, test for stable loop
Libconf::Test::display(6);
$samba = new Libconf::Glueconf::Samba::Smb_conf({ filename => 'smb.conf' });
$samba->write_conf('samba_output_6');
$samba = new Libconf::Glueconf::Samba::Smb_conf({ filename => 'samba_output_6' });
$samba->write_conf('samba_output_6');
Libconf::Test::test(6);

# # test 7, test for comments
# $samba = new Libconf::Glueconf::Samba::Smb_conf({ filename => 'smb.conf' });
# my $comments = $samba->get_comments('{global}');
# $comments->{normal} = uc($comments->{normal});
# $samba->set_comments('{global}', $comments);
# $comments = $samba->get_comments('{global}{workgroup}');
# $comments->{normal} = uc($comments->{normal});
# $samba->set_comments('{global}{workgroup}', $comments);
# $samba->write_conf('samba_output_7');
# Libconf::Test::test(7);

# # test 8, test for comments
# my $samba = new Libconf::Glueconf::Samba::Smb_conf({ filename => 'smb.conf',
#                                                      show_commented_info => 1
#                                                    });
# use Data::Dumper;
# print Dumper($samba->{libconf}) . "\n";
# print " commented : " . $samba->commented('{global}{security}') . "\n";
# $samba->commented('{global}{security}')  and $samba->set_commented('{global}{testdata}', 0);
# print Dumper($samba) . "\n";
# $samba->write_conf('samba_output_8');
# Libconf::Test::test(8);

Libconf::Test::display(-1);
