#!/usr/bin/perl

use Libconf qw(:functions);
use Libconf::Test;
$Libconf::Test::test_module_name = 'xf86config';
use Data::Dumper;

use Libconf::Templates::XF86Config;

# test 1, minimal requirement : regenerate correctly
Libconf::Test::display(1);
my $template = new Libconf::Templates::XF86Config({filename => 'XF86Config'});
$template->read_conf();
$template->write_conf('xf86config_output_1');
Libconf::Test::test(1);

# test 2, test for stable loop
Libconf::Test::display(2);
$template = new Libconf::Templates::XF86Config({filename => 'XF86Config'});
$template->read_conf();
$template->write_conf('xf86config_output_2');
$template = new Libconf::Templates::XF86Config({filename => 'xf86config_output_2'});
$template->read_conf();
$template->write_conf('xf86config_output_2');
Libconf::Test::test(2);

# test 3, editing an atom
Libconf::Test::display(3);
$template = new Libconf::Templates::XF86Config({filename => 'XF86Config'});
$template->read_conf();
$template->edit_atom(-1,
                    {
                     type => 'KEY_VALUE',
                     sections => [
                                  {
                                   'name' => 'Device'
                                  }
                                 ],
                     key => 'Identifier',
                    },
                    {
                     value => '"Matrox Millennium G450 1 TESTING"',
                    }
                   );
$template->write_conf("xf86config_output_3");
Libconf::Test::test(3);

Libconf::Test::display(-1);
