#!/usr/bin/perl

use Libconf qw(:functions);
use Libconf::Test;
$Libconf::Test::test_module_name = 'msec';

use Libconf::Templates::Samba;

# test 1, minimal requirement : regenerate correctly
Libconf::Test::display(1);
my $template = new Libconf::Templates::Generic::KeyValue({
                                                          filename => 'level.local',
                                                          _input_function => sub {
                                                              my ($self, $in, $atom, $parser_env) = @_;
                                                              if ($in =~ s/^\s*(\S+)\s*\((\S+)\)\s*$//) {
                                                                  $atom->{type} = 'KEY_VALUE';
                                                                  $atom->{key} = $1;
                                                                  $atom->{value} = $2;
                                                                  return ($in, 'stop');
                                                              }
                                                              ($in, 'failed');
                                                          },
                                                          _output_function => sub {
                                                              my ($self, $atom, $parser_env) = @_;
                                                              $atom->{type} eq 'KEY_VALUE' and
                                                                return (qq($atom->{key} ($atom->{value})), 0);
                                                              $self->_output_atom($atom);
                                                          },
                                                         });
$template->read_conf();
$template->write_conf('msec_output_1');
Libconf::Test::test(1);

# test 2, test for stable loop
Libconf::Test::display(2);
$template->read_conf();
$template->write_conf('msec_output_2');
$template->read_conf('msec_output_2');
$template->write_conf('msec_output_2');
Libconf::Test::test(2);

# test 3, editing an atom
Libconf::Test::display(3);
$template->read_conf();
$template->edit_atom(-1, {key => 'enable_ip_spoofing_protection'}, {value => 'no'});
$template->write_conf('msec_output_3');
Libconf::Test::test(3);

Libconf::Test::display(-1);
