#!/usr/bin/perl

use Libconf qw(:functions);
use Libconf::Test;
$Libconf::Test::test_module_name = 'group';

use Libconf::Templates::Group;

# test 1, minimal requirement : regenerate correctly
Libconf::Test::display(1);
my $template = new Libconf::Templates::Group({filename => 'group'});
$template->read_conf();
$template->write_conf('group_output_1');
Libconf::Test::test(1);

# test 2, editing an atom
Libconf::Test::display(2);
$template = new Libconf::Templates::Group({filename => 'group'});
$template->read_conf();
$template->edit_atom(-1, 
                     { key => 'daemon' },
                     {  values => {
                                   passwd => 'xtest',
                                   GID => '000456',
                                   user_list => 'root2,bin2,daemon2',
                                  },
                     });
$template->write_conf('group_output_2');
Libconf::Test::test(2);

# test 3, appending an atom
Libconf::Test::display(3);
$template = new Libconf::Templates::Group({filename => 'group'});
$template->read_conf();
$template->append_atom({ key => 'test_libconf',
                         values => {
                                    passwd => 'xtest',
                                    GID => '123',
                                    user_list => 'test1,user2,user3',
                                   },
                         type => 'KEY_VALUES',
                       });
$template->write_conf('group_output_3');
Libconf::Test::test(3);

# test 4, inserting a atom
Libconf::Test::display(4);
$template = new Libconf::Templates::Group({filename => 'group'});
$template->read_conf();
$template->insert_atom(3, { key => 'test_libconf',
                            values => {
                                       passwd => 'xtest',
                                       GID => '123',
                                       user_list => 'test1,user2,user3',
                                      },
                            type => 'KEY_VALUES',
                          });
$template->write_conf("group_output_4");
Libconf::Test::test(4);

Libconf::Test::display(-1);
