#!/usr/bin/perl

use Libconf qw(:functions);
use Libconf::Test;
$Libconf::Test::test_module_name = 'hosts';

# test 1, minimal requirement : regenerate correctly
Libconf::Test::display(1);
my $struct = new Libconf('hosts', 'hosts', '');
$struct->writeConf("hosts_output_1");
Libconf::Test::test(1);

# test 2, test for stable loop
Libconf::Test::display(2);
$struct = new Libconf('hosts', 'hosts', '');
$struct->writeConf("hosts_output_2");
$struct = new Libconf("hosts_output_2", 'hosts', '');
$struct->writeConf("hosts_output_2");
Libconf::Test::test(2);

Libconf::Test::display(3);
$struct = new Libconf('hosts', 'hosts', '');
$struct->editAtom(-1, {
                       'key' => '127.0.0.1',
                       'values' => {
                                    'canonical_hostname' => 'my_localhost',
                                    'aliases' => [qw(test1 test2 test3)],
                                   },
                      });
$struct->writeConf("hosts_output_3");
Libconf::Test::test(3);

Libconf::Test::display(4);
$struct = new Libconf('hosts', 'hosts', '');
$struct->appendAtom({
                     key => '1.2.3.4',
                     values => {
                                  'canonical_hostname' => 'some_localhost',
                                  'aliases' => [qw(test1 test3)],
                                 },
                     type => 'KEY_VALUES',
                    });
$struct->writeConf("hosts_output_4");
Libconf::Test::test(4);

Libconf::Test::display(5);
$struct = new Libconf('hosts', 'hosts', '');
$struct->insertAtom(1, {
                        key => '1.2.3.4',
                        values => {
                                   'canonical_hostname' => 'some_other_localhost',
                                   'aliases' => [qw(test2 test3)],
                                  },
                        type => 'KEY_VALUES',
                       });
$struct->writeConf("hosts_output_5");
Libconf::Test::test(5);

Libconf::Test::display(-1);
