#!/usr/bin/perl

use Libconf qw(:helpers);
use Libconf::Test;
$Libconf::Test::test_module_name = 'inittab';

use Libconf::Templates::Inittab;

# test 1, minimal requirement : regenerate correctly
Libconf::Test::display(1);
my $template = new Libconf::Templates::Inittab({ filename => 'inittab' });
$template->read_conf();
$template->write_conf("inittab_output_1");
Libconf::Test::test(1);

# test 2, editing an atom
Libconf::Test::display(2);
$template = new Libconf::Templates::Inittab({ filename => 'inittab' });
$template->read_conf();
$template->edit_atom(-1,
                     { key => 'l4' },
                     { values => { runlevels => '45',
                                   action => 'once',
                                   process => '/etc/rc.d/rc 5',
                                 },
                     }
                    );
$template->write_conf("inittab_output_2");
Libconf::Test::test(2);

# test 3, appending an atom
Libconf::Test::display(3);
$template = new Libconf::Templates::Inittab({ filename => 'inittab' });
$template->read_conf();
$template->append_atom({ key => '7',
                         values => { runlevels => '2345',
                                     action => 'respawn',
                                     process => '/sbin/mingetty tty6',
                                   },
                         type => 'KEY_VALUES',
                       });
$template->write_conf("inittab_output_3");
Libconf::Test::test(3);

# test 4, inserting a atom
Libconf::Test::display(4);
$template = new Libconf::Templates::Inittab({ filename => 'inittab' });
$template->read_conf();
$template->insert_atom(12,
                       { key => '9',
                         values => { runlevels => '2345',
                                     action => 'respawn',
                                     process => '/sbin/mingetty tty6',
                                   },
                         type => 'KEY_VALUES',
                       });
$template->write_conf("inittab_output_4");
Libconf::Test::test(4);

# test 5, xml export
$template = new Libconf::Templates::Inittab({ filename => 'inittab' });
if (can_XML()) {
    Libconf::Test::display(5);
    $template->read_conf();
    $template->toXMLFile('inittab_output_5', 1);
    Libconf::Test::test(5);
} else {
    Libconf::Test::skip(5);
}

Libconf::Test::display(-1);
