#!/usr/bin/perl

use Libconf qw(:functions);
use Libconf::Test;
$Libconf::Test::test_module_name = 'nagios';

# test 1, minimal requirement : regenerate correctly
Libconf::Test::display(1);
my $struct = new Libconf("hostgroups.cfg", 'nagios', '');
$struct->writeConf("nagios_output_1");
Libconf::Test::test(1);

# test 2, editing an atom
Libconf::Test::display(2);
$struct = new Libconf("hostgroups.cfg", 'nagios', '');
$struct->editAtom(-1, {key => 'members', list => [ 'test1', 'tutu' ],  sections => [{name => 'hostgroup'}]});
$struct->writeConf("nagios_output_2");
Libconf::Test::test(2);

# test 3, appending an atom
Libconf::Test::display(3);
$struct = new Libconf("hostgroups.cfg", 'nagios', '');
$struct->appendAtom({section_name => 'section', type => 'SECTION', 'sections' => [] });
$struct->appendAtom({key => 'alias2', list => [ 'some', 'stuff' ], type => 'KEY_LIST' });
$struct->appendAtom({type => 'ENDSECTION', 'sections' => [] });
$struct->writeConf("nagios_output_3");
Libconf::Test::test(3);

# # test 4, inserting a atom
# display(4);
# $struct = new Libconf("hostgroups.cfg", 'nagios', '');
# Libconf::insertAtom($struct,
#                     ($struct->findAtomPos({type => 'KEY_LIST', key => 'alias', sections => [{name => 'hostgroups'}]}))+1,
#                     {key => 'TESTkey', list => [ 'TEST1', 'test2', 'test3'], type => 'KEY_LIST', sections => [{name => 'hostgroups'}]}
#                    );
# $struct->writeConf("nagios_output_4");
# test(4);

# test 5, getting an atom
#display(5);
#$struct = new Libconf("hostgroups.cfg", 'nagios', '');
#my $a = $struct->getAtom(1);
#Libconf::output("smb.conf_output_5", Data::Dumper->Dump([$a],['getatom']) . "\n");
#test(5);

# test 6, test for stable loop
Libconf::Test::display(4);
$struct = new Libconf("hostgroups.cfg", 'nagios', '');
$struct->writeConf("nagios_output_4");
$struct = new Libconf("nagios_output_4", 'nagios', '');
$struct->writeConf("nagios_output_4");
Libconf::Test::test(4);

Libconf::Test::display(-1);
