#!/usr/bin/perl

use Libconf qw(:helpers);
use Libconf::Test;
$Libconf::Test::test_module_name = 'passwd';

use Libconf::Templates::Passwd;

# test 1, minimal requirement : regenerate correctly
Libconf::Test::display(1);
my $template = new Libconf::Templates::Passwd({filename => 'passwd'});
$template->read_conf();
$template->write_conf('passwd_output_1');
Libconf::Test::test(1);

# test 2, editing an atom
Libconf::Test::display(2);
$template = new Libconf::Templates::Passwd({filename => 'passwd'});
$template->read_conf();
$template->edit_atom(-1,
                     { key => 'adm' },
                     { values => {  passwd => 'xtest',
                                    UID => '000123',
                                    GID => '000456',
                                    GECOS => 'This a test stuff',
                                    directory => '/home/test',
                                    shell => '/bin/bash',
                                 },
                     });
$template->write_conf('passwd_output_2');
Libconf::Test::test(2);

# test 3, appending an atom
Libconf::Test::display(3);
$template = new Libconf::Templates::Passwd({filename => 'passwd'});
$template->read_conf();
$template->append_atom( { key => 'account_test',
                          values => { passwd => 'xtest',
                                      UID => '000123',
                                      GID => '000456',
                                      GECOS => 'This a test stuff',
                                      directory => '/home/test',
                                      shell => '/bin/bash',
                                    },
                          type => 'KEY_VALUES',
                        });
$template->write_conf('passwd_output_3');
Libconf::Test::test(3);

# test 4, inserting a atom
Libconf::Test::display(4);
$template = new Libconf::Templates::Passwd({filename => 'passwd'});
$template->read_conf();
$template->insert_atom(5 ,{ key => 'account_test',
                            values => { account => 'account_test',
                                        passwd => 'xtest',
                                        UID => '000123',
                                        GID => '000456',
                                        GECOS => 'This a test stuff',
                                        directory => '/home/test',
                                        shell => '/bin/bash',
                                      },
                            type => 'KEY_VALUES',
                          });
$template->write_conf('passwd_output_4');
Libconf::Test::test(4);

# test 5, xml export
$template = new Libconf::Templates::Passwd({filename => 'passwd'});
if (can_XML()) {
    Libconf::Test::display(5);
    $template->read_conf();
    $template->toXMLFile('passwd_output_5', 1);
    Libconf::Test::test(5);
} else {
    Libconf::Test::skip(5);
}


Libconf::Test::display(-1);
