#!/usr/bin/perl

use Libconf qw(:functions);
$Libconf::Strict = 0;
use Data::Dumper;
use Libconf::Test;
$Libconf::Test::test_module_name = 'proxy';

use Libconf::Templates::Shell;

# test 1, minimal requirement : regenerate correctly
Libconf::Test::display(1);
my $template = new Libconf::Templates::Shell({
                                              filename => 'proxy.sh',
                                              export_line => 1,
                                              export_only_defined => 0,
                                             });
$template->read_conf();
$template->write_conf("proxy_output_1");
Libconf::Test::test(1);

# test 2, editing an atom
Libconf::Test::display(2);
my $template = new Libconf::Templates::Shell({
                                              filename => 'proxy.sh',
                                              export_line => 1,
                                              export_only_defined => 0,
                                             });
$template->read_conf();
$template->edit_atom(-1, {key => 'http_proxy'}, {value => 'test.com'});
$template->write_conf("proxy_output_2");
Libconf::Test::test(2);

Libconf::Test::display(-1);
