#!/usr/bin/perl

use Libconf qw(:functions);
use Libconf::Test;
$Libconf::Test::test_module_name = 'ups.conf';

use Libconf::Templates::Ups;

# test 1, minimal requirement : regenerate correctly
Libconf::Test::display(1);
my $template = new Libconf::Templates::Ups({filename=>'ups.conf'});
$template->read_conf();
$template->write_conf("ups.conf_output_1");
Libconf::Test::test(1);

# test 2, editing an atom
Libconf::Test::display(2);
my $template = new Libconf::Templates::Ups({filename=>'ups.conf'});
$template->read_conf();
$template->edit_atom(-1, {key => 'driver', sections => [{name => 'myups'}] }, { value => 'TEST' });
$template->write_conf("ups.conf_output_2");
Libconf::Test::test(2);

# test 3, test for stable loop
Libconf::Test::display(3);
my $template = new Libconf::Templates::Ups({filename=>'ups.conf'});
$template->read_conf();
$template->write_conf("ups.conf_output_3");
my $template = new Libconf::Templates::Ups({filename=>'ups.conf_output_3'});
$template->read_conf();
$template->write_conf("ups.conf_output_3");
Libconf::Test::test(2);

Libconf::Test::display(-1);
